﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace SensorLib.NetCf39 
{
    public class DHT11 : IDisposable
    {
        private uint handle=0;

        public DHT11(uint pin)
        {
            handle = DHT11_Init(pin);
        }

        public bool Read(out double humidity, out double temperature)
        {
            if (handle == 0)
            {
                humidity = 0.0;
                temperature = 0.0;
                return false;
            }

            return (DHT11_Read(handle, out humidity, out temperature)) == 0 ? false : true;
        }

        public void Release()
        {
            if (handle != 0)
            {
                DHT11_Release(handle);
                handle = 0;
            }
        }
        

        [DllImport("sensorlib.dll")]
        private static extern uint DHT11_Init(uint pin);

        [DllImport("sensorlib.dll")]
        private static extern uint DHT11_Read(uint instance, out double humidity, out double temperature);

        [DllImport("sensorlib.dll")]
        private static extern uint DHT11_Release(uint instance);

        public void Dispose()
        {
            if (handle != 0)
                DHT11_Release(handle);
        }
    }
}
