﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace SensorLib.NetCf39
{
    public class Stepper
    {
        private uint handle=0;

        public Stepper(uint[] pins)
        {
            handle=Stepper_Init(pins[0],pins[1],pins[2],pins[3]);
        }

        public void Start()
        {
            Stepper_Start(handle);
        }

        public void Stop()
        {
            Stepper_Stop(handle);
        }

        public void Release()
        {
            Stepper_Release(handle);
        }

        [DllImport("sensorlib.dll")]
        private static extern uint Stepper_Init(uint pin0,uint pin1,uint pin2,uint pin3);

        [DllImport("sensorlib.dll")]
        private static extern void Stepper_Release(uint instance);

        [DllImport("sensorlib.dll")]
        private static extern void Stepper_Start(uint instance);

        [DllImport("sensorlib.dll")]
        private static extern void Stepper_Stop(uint instance);

        public void Dispose()
        {
            if (handle != 0)
                Stepper_Release(handle);
        }
    }
}
