﻿using System;
#if (MF_FRAMEWORK_VERSION_V4_3)
using Microsoft.SPOT;
#endif

namespace IoT.Device.Actuators
{
    /// <summary>
    /// Washing end delegate
    /// </summary>
    /// <param name="sender">Object sender</param>
    /// <param name="e">Event args</param>
    public delegate void WashingEndCallback(object sender, EventArgs e);

    /// <summary>
    /// Interface for washing system
    /// </summary>
    public interface IWashing
    {
        /// <summary>
        /// Start washing program
        /// </summary>
        /// <param name="program">Program number</param>
        /// <param name="speed">Speed</param>
        /// <param name="temperature">Temperature</param>
        /// <returns>Operation result</returns>
        bool Start(int program, int speed, int temperature);

        /// <summary>
        /// Stop washing program
        /// </summary>
        /// <returns>Operation result</returns>
        bool Stop();

        /// <summary>
        /// Event raised on wahing end
        /// </summary>
        event WashingEndCallback OnWashingEnd;
    }
}
