﻿using System;
using System.Threading;
#if (MF_FRAMEWORK_VERSION_V4_3)
using Microsoft.SPOT;
#endif

namespace IoT.Device.Actuators
{
    /// <summary>
    /// Washing system class
    /// </summary>
    public class Washing : IWashing
    {
        private const int WASHING_DURATION = 30000;

        // timer (one shot) to emulate washing program
        private Timer timer;

        /// <summary>
        /// Constructor
        /// </summary>
        public Washing()
        {

        }

        #region IWashing ...

        public bool Start(int program, int speed, int temperature)
        {
            // emulate washing program with a timer
            this.timer = new Timer(TimerCallback, null, WASHING_DURATION, Timeout.Infinite);
            return true;
        }

        public bool Stop()
        {
            if (this.timer != null)
                // stop timer
                this.timer.Change(Timeout.Infinite, Timeout.Infinite);
            
            return true;
        }

        public event WashingEndCallback OnWashingEnd;

        #endregion

        private void TimerCallback(object state)
        {
            // stop wahing program
            this.Stop();

            WashingEndCallback callback = this.OnWashingEnd;

            if (callback != null)
                callback(this, EventArgs.Empty);
        }
    }
}
